/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { ScatterItemSearchMode_$type } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "igniteui-react-core";
import { ScatterFrame } from "./ScatterFrame";
import { Base, runOn, delegateCombine, enumGetBox, Number_$type, typeCast, fromEnum, Point_$type, markType, markDep, PointUtil } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { GeometryUtil } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { PathGeometry } from "igniteui-react-core";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterBase = /*@__PURE__*/ (() => {
    class ScatterBase extends MarkerSeries {
        cq() {
            return new ScatterBaseView(this);
        }
        oz() {
            super.oz();
            this.xAxis = null;
            this.yAxis = null;
        }
        qw(a) {
            super.qw(a);
            this.yo = a;
        }
        get_fu() {
            return true;
        }
        ai() {
            return [this.xAxis, this.yAxis];
        }
        ko(a, b) {
            let c = this.na(b);
            if (c == ScatterBase.$$p[12]) {
                return this.kp(a, b, this.aak);
            }
            if (c == ScatterBase.$$p[16]) {
                return this.kp(a, b, this.aas);
            }
            if (c == ScatterBase.$$p[1]) {
                return this.kp(a, b, this.z4);
            }
            if (c == ScatterBase.$$p[2]) {
                return this.kp(a, b, this.z6);
            }
            return null;
        }
        ma(a) {
            let b = this.na(a);
            if (b == ScatterBase.$$p[12]) {
                return this.aak;
            }
            if (b == ScatterBase.$$p[16]) {
                return this.aas;
            }
            if (b == ScatterBase.$$p[1]) {
                return this.z4;
            }
            if (b == ScatterBase.$$p[2]) {
                return this.z6;
            }
            return super.ma(a);
        }
        d9(a, b, c, d) {
            if (!this.hasMarkers) {
                return false;
            }
            let e = this.xAxis;
            let f = new ScalerParams(1, this.c9.vl, this.wk, e.ch);
            f.c = this.getEffectiveViewport1(this.ct);
            let g = this.yAxis;
            let h = new ScalerParams(1, this.c9.vl, this.wk, g.ch);
            h.c = this.getEffectiveViewport1(this.ct);
            a.clear();
            this.wx.cj((i) => {
                if (i._visibility == 0) {
                    let j = new SeriesPointOfInterest();
                    let k = i.n;
                    let l = i.o;
                    if (k < this.wk.left || k > this.wk.right || l < this.wk.top || l > this.wk.bottom) {
                        return;
                    }
                    j.d = e.en(k, f);
                    j.e = g.en(l, h);
                    j.b = i.content;
                    j.g = this.u9;
                    j.c = i.ak;
                    if (this.g7) {
                        j.g = this.vg(i.ak);
                    }
                    a.add(j);
                }
            });
            return true;
        }
        b0() {
            if (this.b1 == 0) {
                if (this.z0 <= 2000) {
                    return 1;
                }
                else {
                    return super.b0();
                }
            }
            else {
                return super.b0();
            }
        }
        wi(a) {
            if (!this.hasMarkers || !this.w7()) {
                return Rect.empty;
            }
            let b = this.wx.b1(this.v0(a));
            if (b != null) {
                return this.wx.cu(b);
            }
            return Rect.empty;
        }
        gu(a, b) {
            if (this.w8(a, b)) {
                return true;
            }
            return false;
        }
        constructor() {
            super();
            this.yn = null;
            this.y6 = null;
            this.y7 = null;
            this.acb = null;
            this.acc = null;
            this.yw = 1;
            this.yd = null;
            this.ye = null;
            this.yt = null;
            this.yv = null;
            this.yr = null;
            this.zc = false;
            this.zb = false;
            this.y4 = null;
            this.y5 = null;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.y0 = null;
            this.yu = null;
            this.yq = null;
            this.za = true;
            this.zp = 0;
            this.zq = 0;
            this.zr = 0;
            this.zs = 0;
            this.yx = this.yy();
            this.y0 = new ScatterSeriesRenderManager();
            this.yu = new ScatterFrame();
            this.acc = Rect.empty;
            this.acb = Rect.empty;
        }
        get y8() {
            return this.y6;
        }
        set y8(a) {
            if (this.y6 != a) {
                let b = this.y8;
                this.y6 = a;
                this.raisePropertyChanged("XColumn", b, this.y8);
            }
        }
        get y9() {
            return this.y7;
        }
        set y9(a) {
            if (this.y7 != a) {
                let b = this.y9;
                this.y7 = a;
                this.raisePropertyChanged("YColumn", b, this.y9);
            }
        }
        f9() {
            return this.highlightedItemsSource != null || (this.z4 != null && this.z6 != null);
        }
        zn() {
            return false;
        }
        hr() {
            let a = super.hr();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "YMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedYMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.aaz));
                a.add(b);
            }
            {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "XMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedXMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.aay));
                a.add(c);
            }
            if (this.zn()) {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "DashArray";
                    $ret.p = true;
                    $ret.x = ((() => {
                        let $ret = new DoubleCollection();
                        $ret.add(5);
                        $ret.add(5);
                        return $ret;
                    })());
                    $ret.q = true;
                    return $ret;
                })());
                a.add(d);
            }
            if (!this.zn()) {
                let e = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                e.valueResolving = delegateCombine(e.valueResolving, runOn(this, this.ru));
                a.add(e);
            }
            if (!this.zn()) {
                let f = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                f.valueResolving = delegateCombine(f.valueResolving, runOn(this, this.ru));
                a.add(f);
            }
            return a;
        }
        aay(a, b) {
            if (this.z4 != null) {
                b.value = this.z4;
                return;
            }
            b.value = this.aak;
        }
        aaz(a, b) {
            if (this.z6 != null) {
                b.value = this.z6;
                return;
            }
            b.value = this.aas;
        }
        get ab8() {
            return this.c(ScatterBase.abj);
        }
        set ab8(a) {
            this.h(ScatterBase.abj, a);
        }
        get GetErrorBarsXAxis() {
            return this.xAxis;
        }
        get GetErrorBarsYAxis() {
            return this.yAxis;
        }
        p5() {
            super.p5();
            if (this.xAxis != null) {
                this.xAxis.h9(false);
            }
            if (this.yAxis != null) {
                this.yAxis.h9(false);
            }
        }
        q4(a, b, c, d) {
            super.q4(a, b, c, d);
            if (this.yo.c2.g$b(a, b, c, d)) {
                this.rm(false);
                this.qg();
            }
            switch (b) {
                case ScatterBase.$$p[10]:
                case ScatterBase.$$p[14]:
                case ScatterBase.$$p[11]:
                case ScatterBase.$$p[15]:
                    this.qa();
                    break;
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.y8);
                        c.deregisterColumn(this.y9);
                        this.y8 = null;
                        this.y9 = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.y8 = this.di(this.aak);
                        this.y9 = this.di(this.aas);
                    }
                    if ((this.yAxis != null && !this.yAxis.c1()) || (this.xAxis != null && !this.xAxis.c1())) {
                        this.rm(this.ge && c != null);
                    }
                    break;
                case ScatterBase.$$p[9]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    if ((this.xAxis != null && !this.xAxis.c1()) || (d == null && c != null)) {
                        this.rm(false);
                    }
                    this.qg();
                    break;
                case ScatterBase.$$p[13]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    if ((this.yAxis != null && !this.yAxis.c1()) || (d == null && c != null)) {
                        this.rm(false);
                    }
                    this.qg();
                    break;
                case ScatterBase.$$p[12]:
                    if (this.dl != null) {
                        this.dl.deregisterColumn(this.y8);
                        this.y8 = this.di(this.aak);
                    }
                    break;
                case "XColumn":
                    this.yo.c2.g$i();
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.rm(this.ge && this.d5);
                    }
                    break;
                case ScatterBase.$$p[16]:
                    if (this.dl != null) {
                        this.dl.deregisterColumn(this.y9);
                        this.y9 = this.di(this.aas);
                    }
                    break;
                case "YColumn":
                    this.yo.c2.g$i();
                    if (this.yAxis != null && !this.yAxis.c1()) {
                        this.rm(this.ge && this.d5);
                    }
                    break;
                case ScatterBase.$$p[7]:
                    this.rm(false);
                    this.qg();
                    break;
                case ScatterBase.$$p[8]:
                    this.rm(false);
                    this.qg();
                    break;
                case "TransitionProgress":
                    this.yv.c(this.jo, this.yt, this.yr);
                    this.aau();
                    try {
                        if (this.d3(this.ct)) {
                            return;
                        }
                        if ((Math.round(this.jo * 100000) / 100000) == 1) {
                            this.abg(this.yr, this.yo);
                        }
                        else {
                            this.abg(this.yv, this.yo);
                        }
                        if (this.c9 != null) {
                            this.c9.qa(this);
                        }
                    }
                    finally {
                        this.abh();
                    }
                    break;
                case "TrendLineBrush":
                    this.ra(b);
                    break;
                case ScatterBase.$$p[0]:
                    if (this.yp != null) {
                        this.yp.r = this;
                    }
                    this.rm(false);
                    this.qg();
                    break;
                case "TrendLineType":
                    this.qg();
                    break;
                case ScatterBase.$$p[4]:
                    this.zc = this.zk();
                    this.rm(false);
                    break;
                case ScatterBase.$$p[3]:
                    this.zb = this.zj();
                    this.rm(false);
                    break;
                case ScatterBase.$$p[5]:
                    this.yx = this.yy();
                    break;
            }
        }
        zk() {
            return this.zg;
        }
        zj() {
            return this.zf;
        }
        ze(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        zd(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        abh() {
            this.acb = Rect.empty;
            this.acc = Rect.empty;
        }
        aau() {
            let a = this.getViewInfo(this.acb, this.acc);
            this.acb = a.p0;
            this.acc = a.p1;
        }
        zi(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.aak == a || this.aas == a) {
                return true;
            }
            return false;
        }
        o8(a, b, c, d) {
            let e = false;
            if (!this.zi(d, a)) {
                return;
            }
            this.yo.c2.g$e(a, b, c, d);
            if (this.xAxis != null && !this.xAxis.c1()) {
                e = true;
            }
            if (this.yAxis != null && !this.yAxis.c1()) {
                e = true;
            }
            if (a == 0 || a == 2 || a == 3 || a == 4) {
                this.za = true;
            }
            else if (a == 1) {
                for (let f = b; f < b + c; f++) {
                    this.zp += this.y8.item(f);
                    this.zq += this.y9.item(f);
                }
                this.zr = this.zp / this.y8.count;
                this.zs = this.zq / this.y9.count;
            }
            if (e) {
                this.rm(true);
            }
        }
        aa8(a) {
            this.aa9(a, null);
        }
        aa9(a, b) {
            let c = this.y8 != null ? this.y8.count : 0;
            let d = this.y9 != null ? this.y9.count : 0;
            let e = Math.min(c, d);
            if (e <= this.z0) {
                a.m.clear();
                let f = new List$1(OwnedPoint.$, 0);
                for (let g of fromEnum(a.u.values)) {
                    f.add(g);
                }
                let h = this.dl;
                f.aa((i, j) => {
                    let k = h.indexOf(i.a);
                    let l = h.indexOf(j.a);
                    if (k < l) {
                        return -1;
                    }
                    if (k > l) {
                        return 1;
                    }
                    return 0;
                });
                if (b != null) {
                    b.i = a.m;
                }
                for (let i of fromEnum(f)) {
                    if (h.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
        }
        ax(a) {
            if (a != null && a == this.xAxis && this.y8 != null) {
                return new AxisRange(this.y8.minimum, this.y8.maximum);
            }
            if (a != null && a == this.yAxis && this.y9 != null) {
                return new AxisRange(this.y9.minimum, this.y9.maximum);
            }
            return null;
        }
        kl(a) {
            let b = this.j1(a);
            if (this.dl != null && b >= 0 && b < this.dl.count) {
                return this.dl.item(b);
            }
            return null;
        }
        get yx() {
            return this.yw;
        }
        set yx(a) {
            let b = this.yw;
            this.yw = a;
            if (b != this.yw) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ScatterItemSearchMode_$type, b), enumGetBox(ScatterItemSearchMode_$type, this.yw));
            }
        }
        yy() {
            if (this.yz != 0) {
                return this.yz;
            }
            return this.zh ? 4 : 1;
        }
        j1(a) {
            let b = truncate(Math.round(this.ip(a)));
            return b;
        }
        ip(a) {
            switch (this.yx) {
                case 1: return this.zw(a);
                case 3: return this.zx(a);
                case 2: return this.zu(a);
                case 4: return this.zv(a);
                case 5: return this.zt(a);
            }
            return -1;
        }
        zv(a) {
            return this.zy(a, false);
        }
        zu(a) {
            let b = this.v0(a);
            let c = b.x;
            let d = b.y;
            if (this.dl == null || this.xAxis == null || this.yAxis == null || this.y8 == null || this.y9 == null) {
                return -1;
            }
            if (this.dl.count > this.zz) {
                return -1;
            }
            this.aax();
            let e = this.yd;
            let f = this.ye;
            if (e == null || f == null) {
                return -1;
            }
            let g = 1.7976931348623157E+308;
            let h = -1;
            for (let i = 0; i < this.y8.count; i++) {
                let j = e[i];
                let k = f[i];
                let l = (c - j) * (c - j) + (d - k) * (d - k);
                if (l < g) {
                    g = l;
                    h = i;
                }
            }
            return h;
        }
        aax() {
            let a = this.ct.by;
            let b = this.ct.bx;
            let c = this.getEffectiveViewport();
            if (this.yn == null) {
                return;
            }
            let d = new ScalerParams(0, a, b, this.yn.d, c);
            let e = ((() => {
                let $ret = new ScalerParams(0, a, b, this.yn.e, c);
                $ret.b = this.iw();
                return $ret;
            })());
            if (this.yd == null || this.ye == null) {
                let f = arrayShallowClone(this.y8.asArray());
                let g = arrayShallowClone(this.y9.asArray());
                this.xAxis.ho(boxArray$1(f), 0, f.length, d);
                this.yAxis.ho(boxArray$1(g), 0, g.length, e);
                this.yd = f;
                this.ye = g;
            }
        }
        get_zh() {
            return false;
        }
        get zh() {
            return this.get_zh();
        }
        zy(a, b) {
            if (!this.zh) {
                return -1;
            }
            let c = { $type: Point_$type, x: 0, y: 0 };
            let d = true;
            let e = this.ys();
            if (e == null) {
                return -1;
            }
            if (e.m == null) {
                return -1;
            }
            if (this.dl == null || this.dl.count > this.zz) {
                return -1;
            }
            this.aax();
            let f = this.yd;
            let g = this.ye;
            if (f == null || g == null) {
                return -1;
            }
            let h = this.v0(a);
            let i = 1.7976931348623157E+308;
            let j = -1;
            for (let k = 0; k < this.yd.length; k++) {
                let l = { $type: Point_$type, x: this.yd[k], y: this.ye[k] };
                if (k > 0) {
                    if (!b || e.j.containsKey(this.dl.item(k)) || e.j.containsKey(this.dl.item(k - 1))) {
                        let m = GeometryUtil.g(h, c, l);
                        if (m < i) {
                            i = m;
                            j = k;
                        }
                    }
                }
                c = l;
            }
            if (j >= 0) {
                let n = { $type: Point_$type, x: this.yd[j], y: this.ye[j] };
                let o = { $type: Point_$type, x: this.yd[j - 1], y: this.ye[j - 1] };
                if (!b || (e.j.containsKey(this.dl.item(j)) && e.j.containsKey(this.dl.item(j - 1)))) {
                    let p = GeometryUtil.l(h, o, n);
                    return (j - 1) + p;
                }
                else if (e.j.containsKey(this.dl.item(j))) {
                    return j;
                }
                else {
                    return j - 1;
                }
            }
            return -1;
        }
        zx(a) {
            return this.zy(a, true);
        }
        zt(a) {
            let b = this.v0(a);
            let c = b.x;
            let d = b.y;
            if (this.yo.c3.e > this.zz) {
                return -1;
            }
            let e = -1;
            this.wx.ck((f) => {
                let g = this.yo.cu(f);
                let h = g.left;
                let i = g.top;
                let j = g.width;
                let k = g.height;
                if (this.w4) {
                    let l = h + j / 2;
                    let m = i + k / 2;
                    let n = (j / 2) * (j / 2);
                    let o = (c - l) * (c - l) + (d - m) * (d - m);
                    if (o < n) {
                        if (e == -1) {
                            e = f.ak;
                        }
                    }
                }
                else {
                    if (c > h && c < h + j && d > i && d < i + k) {
                        if (e == -1) {
                            e = f.ak;
                        }
                    }
                }
            });
            return e;
        }
        zw(a) {
            let b = null;
            let c = 1.7976931348623157E+308;
            let d = this.v0(a);
            let e = d.x;
            let f = d.y;
            if (this.yo.c3.e > this.zz) {
                return -1;
            }
            this.yo.da((g) => {
                if (g._visibility == 0) {
                    let h = this.yo.cu(g);
                    let i = h.left + h.width / 2;
                    let j = h.top + h.height / 2;
                    let k = (e - i) * (e - i) + (f - j) * (f - j);
                    if (k < c) {
                        c = k;
                        b = g;
                    }
                }
            });
            if (b != null) {
                return b.ak;
            }
            return -1;
        }
        v5(a, b, c) {
            if (this.xAxis == null || this.yAxis == null || this.y8 == null || this.y9 == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let d = this.ct.by;
            let e = this.ct.bx;
            let f = this.getEffectiveViewport();
            let g = new ScalerParams(0, d, e, this.xAxis.ch, f);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.ch, f);
                $ret.b = this.iw();
                return $ret;
            })());
            if (b) {
                let i = this.ip(a);
                if (i == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let j = truncate(Math.floor(i));
                let k = truncate(Math.ceil(i));
                if (j < 0) {
                    j = 0;
                }
                if (k < 0) {
                    k = 0;
                }
                if (k > this.dl.count - 1) {
                    k = this.dl.count - 1;
                }
                if (j > this.dl.count - 1) {
                    j = this.dl.count - 1;
                }
                if (k == j) {
                    let l = this.xAxis.ek(this.y8.item(j), g);
                    let m = this.yAxis.ek(this.y9.item(j), h);
                    return { $type: Point_$type, x: l, y: m };
                }
                let n = i - Math.floor(i);
                let o = this.xAxis.ek(this.y8.item(j), g);
                let p = this.yAxis.ek(this.y9.item(j), h);
                let q = this.xAxis.ek(this.y8.item(k), g);
                let r = this.yAxis.ek(this.y9.item(k), h);
                let s = q - o;
                let t = r - p;
                return { $type: Point_$type, x: o + s * n, y: p + t * n };
            }
            else {
                let u = this.j1(a);
                if (u == -1) {
                    return { $type: Point_$type, x: NaN, y: NaN };
                }
                let v = this.xAxis.ek(this.y8.item(u), g);
                let w = this.yAxis.ek(this.y9.item(u), h);
                return { $type: Point_$type, x: v, y: w };
            }
        }
        gb(a) {
            let b = this.c9 != null ? this.c9.vl : Rect.empty;
            b = b.copy();
            let c = this.c9 != null ? this.c9.v0 : Rect.empty;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = this.we(this.ct);
            let f = new ScalerParams(0, d, d, this.xAxis.ch, e);
            let g = ((() => {
                let $ret = new ScalerParams(0, d, d, this.yAxis.ch, e);
                $ret.b = this.iw();
                return $ret;
            })());
            let h = !b.isEmpty && !c.isEmpty && this.dl != null ? this.dl.indexOf(a) : -1;
            let i = this.xAxis != null && this.y8 != null && h < this.y8.count ? this.xAxis.ek(this.y8.item(h), f) : NaN;
            let j = this.yAxis != null && this.y9 != null && h < this.y9.count ? this.yAxis.ek(this.y9.item(h), g) : NaN;
            if (!isNaN_(i)) {
                if (i < b.left + 0.1 * b.width) {
                    i = i + 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
                if (i > b.right - 0.1 * b.width) {
                    i = i - 0.4 * b.width;
                    b.x = i - 0.5 * b.width;
                }
            }
            if (!isNaN_(j)) {
                if (j < b.top + 0.1 * b.height) {
                    j = j + 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
                if (j > b.bottom - 0.1 * b.height) {
                    j = j - 0.4 * b.height;
                    b.y = j - 0.5 * b.height;
                }
            }
            if (this.c1 != null) {
                this.c1.au(this.c9, b, true);
            }
            return h >= 0;
        }
        sj(a, b) {
            this.rm(false);
        }
        sk(a, b) {
            this.rm(false);
        }
        ys() {
            let a = this.yr;
            if (this.d1()) {
                if (this.da.g) {
                    this.da.t();
                }
                a = this.yv;
            }
            return a;
        }
        aav(a, b, c, d, e) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            let f = this.getEffectiveViewport1(a);
            let g = this.dl;
            let h;
            let i;
            let j = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yn.d, f);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let k = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yn.e, f);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.iw();
                return $ret;
            })());
            let l = false;
            let m = 0;
            if (this.c9 != null) {
                if (this.c9.fz()) {
                    let n = this.c9.mt(d, j);
                    l = n.c;
                    m = n.d;
                }
            }
            for (let o = 0; o < c; o++) {
                h = this.y8.item(o);
                i = this.y9.item(o);
                let p = { $type: Point_$type, x: this.yn.a.ek(h, j), y: this.yn.b.ek(i, k) };
                if (l) {
                    if (p.x < e.left || p.x > e.right) {
                        if (p.x + m >= e.left && p.x + m <= e.right) {
                            p = { $type: Point_$type, x: p.x + m, y: i };
                        }
                    }
                }
                if (!isInfinity(p.x) && !isInfinity(p.y)) {
                    let q = g.item(o);
                    if (!b.g.containsKey(q)) {
                        let r = { $type: Point_$type, x: h, y: i };
                        let s = { $type: Point_$type, x: p.x, y: p.y };
                        b.g.addItem(q, ((() => {
                            let $ret = new OwnedPoint();
                            $ret.a = q;
                            $ret.b = r;
                            $ret.c = s;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        aa5(a, b) {
            this.yd = null;
            this.ye = null;
            a.j.clear();
            a.n.clear();
            a.h.clear();
            a.l.clear();
            a.i.clear();
            a.k.clear();
            let c = Math.min(this.y8 != null ? this.y8.count : 0, this.y9 != null ? this.y9.count : 0);
            let d = b.by;
            let e = b.bx;
            let f = this.getEffectiveViewport1(b);
            let g = new ScalerParams(0, d, e, this.xAxis.ch, f);
            g.c = this.getEffectiveViewport1(b);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.ch, f);
                $ret.b = this.iw();
                return $ret;
            })());
            h.c = this.getEffectiveViewport1(b);
            if (c < 1) {
                return;
            }
            this.yn = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.ch;
                $ret.e = this.yAxis.ch;
                $ret.c = this.dl;
                return $ret;
            })());
            let i = b;
            if (c <= this.z0) {
                this.aav(i, a, c, d, e);
            }
            if (this.w7()) {
                b.c0.l(a.j, this.z0, d, e, this.ib);
            }
            let j = ((() => {
                let $ret = new Clipper(0, e, false);
                $ret.i = a.n;
                return $ret;
            })());
            let k = this.wc(b);
            let l = this.xAxis.en(k.left, g);
            let m = this.xAxis.en(k.right, g);
            b.c2.h(a.n, this.trendLineType, this.y8, this.y9, this.trendLinePeriod, (n) => this.xAxis.ek(n, g), (n) => this.yAxis.ek(n, h), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.d = this.ib;
                $ret.i = e;
                $ret.h = f;
                $ret.j = d;
                return $ret;
            })()), j, l, m);
            this.aa3(a, b);
        }
        o2(a, b) {
            super.o2(a, b);
            let c = b;
            c.c9(a);
        }
        get_fc() {
            return true;
        }
        y2(a, b, c) {
            return null;
        }
        y3(a, b, c) {
            if (this.dl == null) {
                return null;
            }
            let d = this.ys();
            let e = this.yo.b1(this.v0(b));
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.dl.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                f = e.ak;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.i = this;
            g.g = f;
            g.f = f;
            g.c = false;
            g.d = true;
            if (c != null && c.g == g.g && c.f == g.f) {
                return c;
            }
            return g;
        }
        wm(a, b) {
            if (this.wz != 1 && this.wz != 13) {
                let c = this.wx.cv();
                let d = (c.width / 2) + (this.xa / 2);
                let e = (c.height / 2) + (this.xa / 2);
                let f = d;
                let g = d;
                let h = e;
                let i = e;
                if (a == 2 || a == 4) {
                    f = 0;
                }
                if (a == 2 || a == 3) {
                    g = 0;
                }
                if (b == 2 || b == 3) {
                    h = 0;
                }
                if (b == 2 || b == 4) {
                    i = 0;
                }
                return new Thickness(1, f, h, g, i);
            }
            return new Thickness(1, 0, 0, 0, 0);
        }
        y1(a, b, c) {
            let d = new HighlightingInfo();
            d.i = this;
            d.g = 0;
            d.f = this.dl.count - 1;
            d.c = true;
            if (c != null && c.g == d.g && c.f == d.f) {
                return c;
            }
            return d;
        }
        de(a, b, c) {
            if (this.eb && this.fx(this.bv) && !c) {
                let d = this.y2(a, b, this.y4);
                this.y4 = d;
                return d;
            }
            else {
                let e = this.y1(a, b, this.y4);
                this.y4 = e;
                return e;
            }
        }
        df(a, b, c) {
            if (this.fx(this.bv) && !c) {
                let d = this.y3(a, b, this.y5);
                this.y5 = d;
                return d;
            }
            else {
                let e = this.y1(a, b, this.y5);
                e.d = true;
                this.y5 = e;
                return e;
            }
        }
        zm() {
            return (this.assigningScatterStyle != null && this.zc) || this.d0 || (this.bv != 1) || (this.cn != 1) || (this.cm != 1);
        }
        zl() {
            return (this.assigningScatterMarkerStyle != null && this.zb) || this.d0 || (this.bv != 1) || (this.cn != 1) || (this.cm != 1);
        }
        abg(a, b) {
            this.qs();
            let c = b.bx;
            this.yn = ((() => {
                let $ret = new ScatterAxisInfoCache();
                $ret.a = this.xAxis;
                $ret.b = this.yAxis;
                $ret.d = this.xAxis.ch;
                $ret.e = this.yAxis.ch;
                return $ret;
            })());
            if (this.w7()) {
                b.c0.j(a.j, this.w9);
                if (this.zl()) {
                    this.aaw(b, a);
                }
            }
            b.cr();
            let d = ((() => {
                let $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
                $ret.i = b.c2.g$j.an;
                return $ret;
            })());
            b.c2.g$h(a.n, d);
            this.abd(a, b);
        }
        yg(a, b) {
            return this.yh(a, b);
        }
        yh(a, b) {
            if (b < a || a < 0 || a > this.y8.count || b < 0 || b > this.y8.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.dl.item(d);
            }
            return c;
        }
        aaw(a, b) {
            a.b7 = true;
            this.y0.ay(this, this.zl(), runOn(this, this.yg));
            let c = this.y0.d;
            let d = c != null;
            let e = this.getEffectiveViewport1(a);
            let f = this.dl == null ? 0 : this.dl.count;
            this.yo.cj((g) => {
                if (g._visibility == 0) {
                    let h = g.ak;
                    let i = g.content;
                    if (i == null) {
                        i = new DataContext();
                        g.content = i;
                    }
                    if (d) {
                        this.aa0(h, f, a.q);
                    }
                    this.y0.ac(g, i);
                }
            });
        }
        aa1(a, b, c) {
            let d = this.bv != 1;
            let e = this.cn != 1;
            let f = this.cm != 1;
            this.y0.a0(this.y0.b, a, b, false);
            this.y0.ab(this.h9);
            let g = this.y0.ax;
            let h = null;
            let i = null;
            let j = null;
            let k = this.dl;
            if (d && this.c9 != null) {
                h = this.c9.dj.getHighlightingInfo(this, k, g.z, g.y, false);
                g.c = h;
            }
            if (e && this.c9 != null) {
                h = this.c9.dk.getHighlightingInfo(this, k, g.z, g.y, false);
                g.d = h;
            }
            if (f && this.c9 != null) {
                h = this.c9.di.getHighlightingInfo(this, k, g.z, g.y, false);
                g.b = h;
            }
            g.h = c;
            this.abb(g);
            this.y0.z(this, h, i, j, c, d, e, f, a < 0);
        }
        aa0(a, b, c) {
            let d = this.bv != 1;
            let e = this.cn != 1;
            let f = this.cm != 1;
            this.y0.a0(this.y0.d, a, b, true);
            this.y0.aa(this.h9);
            let g = this.y0.aw;
            let h = null;
            let i = null;
            let j = null;
            let k = this.dl;
            let l = null;
            let m = null;
            let n = null;
            if (d && this.c9 != null) {
                h = this.c9.dj.getHighlightingInfo(this, k, g.z, g.y, true);
                if (this.c9.dj.isCrossContextHighlight(this)) {
                    l = this.c9.dj.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.c = h;
            }
            if (e && this.c9 != null) {
                i = this.c9.dk.getHighlightingInfo(this, k, g.z, g.y, true);
                if (i == null && this.bl != null) {
                    i = this.c9.dk.getHighlightingInfo(this.bl, this.bl.dl, g.z, g.y, true);
                }
                if (this.c9.dk.isCrossContextHighlight(this)) {
                    m = this.c9.dk.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.d = i;
            }
            if (f && this.c9 != null) {
                j = this.c9.di.getHighlightingInfo(this, k, g.z, g.y, true);
                if (this.c9.di.isCrossContextHighlight(this)) {
                    n = this.c9.di.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.d = i;
            }
            g.h = c;
            this.aba(g);
            this.y0.y(this, h, i, j, c, d, e, f, g.v, this.c9.dj.totalHighWaterMark, g.x, this.c9.dk.totalHighWaterMark, g.t, this.c9.di.totalHighWaterMark);
        }
        abb(a) {
            if (this.assigningScatterStyle != null && this.zc) {
                this.assigningScatterStyle(this, a);
            }
        }
        aba(a) {
            if (this.assigningScatterMarkerStyle != null && this.zb) {
                this.assigningScatterMarkerStyle(this, a);
            }
        }
        aa3(a, b) {
            let c = new ErrorBarsHelper(this, b);
            if (this.yp == null) {
                return;
            }
            let d = this.yp.u;
            let e = this.yp.v;
            let f = 0;
            let g = 0;
            let h = 0;
            let i = 0;
            for (let j of fromEnum(a.j.keys)) {
                let k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            let l = this.aa6(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            let m = this.aa4(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            let n = this.aa2(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            let o = this.aa7(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            let p = this.aa4(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    let q = new OwnedPoint();
                    q.c = c.l(d, this.yn.a, k.c, f);
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            let r = this.aa6(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            let s = this.aa4(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            let t = this.aa2(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            let u = this.aa7(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            let v = this.aa4(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    let w = new OwnedPoint();
                    w.c = c.m(e, this.yn.b, k.c, g);
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        aa6(a, b, c, d, e, f) {
            if (f) {
                let g;
                let h, i;
                i = this.yn.a;
                if (this.yp.s == 0) {
                    g = a.c.x;
                    h = this.yn.a;
                }
                else {
                    g = a.c.y;
                    h = this.yn.b;
                }
                let j = b.f(g, c, h, i, d, e);
                d = j.p4;
                e = j.p5;
            }
            else {
                let k;
                let l, m;
                m = this.yn.b;
                if (this.yp.t == 0) {
                    k = a.c.x;
                    l = this.yn.a;
                }
                else {
                    k = a.c.y;
                    l = this.yn.b;
                }
                let n = b.f(k, c, l, m, d, e);
                d = n.p4;
                e = n.p5;
            }
            return {
                p3: d,
                p4: e
            };
        }
        aa4(a, b, c, d, e, f) {
            if (f) {
                let g = b.j(a.c.x, c, this.yn.a, d, e);
                d = g.p3;
                e = g.p4;
            }
            else {
                let h = b.j(a.c.y, c, this.yn.b, d, e);
                d = h.p3;
                e = h.p4;
            }
            return {
                p3: d,
                p4: e
            };
        }
        aa2(a, b, c, d, e, f, g) {
            let h = c.getItemColumn();
            let i = this.dl.indexOf(d);
            if (h != null && i < h.count) {
                let j = h.item(i);
                if (g) {
                    let k = b.h(a.c.x, j, this.yn.a, e, f);
                    e = k.p3;
                    f = k.p4;
                }
                else {
                    let l = b.h(a.c.y, j, this.yn.b, e, f);
                    e = l.p3;
                    f = l.p4;
                }
            }
            else {
                e = NaN;
                f = NaN;
            }
            return {
                p4: e,
                p5: f
            };
        }
        aa7(a, b, c, d, e, f) {
            let g = a.i(b, c);
            c = g.p1;
            if (f) {
                let h = a.k(c, b, this.yn.a, d, e);
                d = h.p3;
                e = h.p4;
            }
            else {
                let i = a.k(c, b, this.yn.b, d, e);
                d = i.p3;
                e = i.p4;
            }
            return {
                p2: c,
                p3: d,
                p4: e
            };
        }
        abd(a, b) {
            if (!b.o() || this.yp == null) {
                b.db();
                return;
            }
            this.abe(a, b);
            this.abf(a, b);
        }
        abe(a, b) {
            b.c7();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.yp.u;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.i.containsKey(f)) {
                    let g = a.i.item(f)[0];
                    let h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.h.item(f).c;
                        if (this.yp.o == 1 || this.yp.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.yp.o == 1 || this.yp.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
            b.dc(d);
        }
        abf(a, b) {
            b.c8();
            let c = new ErrorBarsHelper(this, b);
            let d = new PathGeometry();
            let e = this.yp.v;
            for (let f of fromEnum(a.j.keys)) {
                if (e != null && a.k.containsKey(f)) {
                    let g = a.k.item(f)[0];
                    let h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        let i = a.l.item(f).c;
                        if (this.yp.p == 1 || this.yp.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.yp.p == 1 || this.yp.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        hc(a, b, c) {
            let d = true;
            if (!super.hc(a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bi == null || this.yAxis.bi == null || this.y8 == null || this.y9 == null || this.y8.count == 0 || this.y9.count == 0 || this.dl == null || this.dl.count != this.y8.count || this.dl.count != this.y9.count || this.xAxis.bi == null || this.yAxis.bi == null || this.xAxis.ly == this.xAxis.lx || this.yAxis.ly == this.yAxis.lx) {
                d = false;
            }
            return d;
        }
        getViewInfo(a, b) {
            if (!this.acb.isEmpty && !this.acc.isEmpty) {
                a = this.acb;
                b = this.acc;
                return {
                    p0: a,
                    p1: b
                };
            }
            a = this.ct.bx;
            b = this.ct.by;
            return {
                p0: a,
                p1: b
            };
        }
        rn(a) {
            super.rn(a);
            this.aau();
            try {
                if (this.d3(this.ct)) {
                    return;
                }
                if (this.dl != null && this.dl.count > this.z0) {
                    a = false;
                }
                if (this.gd(a) && !this.gp) {
                    let b = this.yt;
                    if (this.d1()) {
                        if (this.da.g) {
                            this.da.t();
                        }
                        this.yt = this.yv;
                        this.yv = b;
                    }
                    else {
                        this.yt = this.yr;
                        this.yr = b;
                    }
                    this.aa5(this.yr, this.yo);
                    this.r0();
                }
                else {
                    if (!this.gp) {
                        this.aa5(this.yr, this.yo);
                    }
                    this.abg(this.yr, this.yo);
                }
            }
            finally {
                this.abh();
            }
        }
        sa() {
            super.sa();
            if (this.index < 0) {
                return;
            }
            this.yo.df();
        }
        ro(a, b) {
            super.ro(a, b);
            if (!this.gy) {
                this.ct.a4(b);
                return;
            }
            this.ct.a4(b);
            if (this.d3(this.cs)) {
                return;
            }
            let c = typeCast(ScatterBaseView.$, this.cs);
            if (!this.gq) {
                this.yu = new ScatterFrame();
                this.aa5(this.yu, c);
            }
            this.gq = false;
            this.abg(this.yu, c);
            this.gy = false;
        }
        rl(a, b, c, d, e) {
            super.rl(a, b, c, d, e);
            let f = this.a9.a$j.item(d);
            let g = f;
            f.a3(c);
            if (this.d3(g)) {
                return;
            }
            if (this.yq == null) {
                this.yq = new ScatterFrame();
            }
            this.aa5(this.yq, g);
            this.abg(this.yq, g);
        }
        abc(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        yf(a, b, c, d, e) {
            if (c == null || c.length != this.yn.c.count) {
                c = new Array(this.yn.c.count);
                for (let f = 0; f < this.yn.c.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = this.getEffectiveViewport1(a);
            let h = ((() => {
                let $ret = new ScalerParams(0, d, e, this.xAxis.ch, g);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = ((() => {
                let $ret = new ScalerParams(0, d, e, this.yAxis.ch, g);
                $ret.c = this.getEffectiveViewport1(a);
                $ret.b = this.iw();
                return $ret;
            })());
            let j = this.wc(a);
            let k = this.yn.a.en(j.left, h);
            let l = this.yn.a.en(j.right, h);
            let m = this.yn.b.en(j.bottom, i);
            let n = this.yn.b.en(j.top, i);
            if (this.yn.d) {
                let o = k;
                k = l;
                l = o;
            }
            if (this.yn.e) {
                let p = m;
                m = n;
                n = p;
            }
            let q = this.yn;
            let r = q.a;
            let s = q.b;
            let t;
            let u;
            let v = this.y8;
            let w = this.y9;
            let x = false;
            let y = 0;
            let z = 0;
            if (this.c9 != null) {
                if (this.c9.fz()) {
                    let aa = this.c9.mt(d, h);
                    x = aa.c;
                    y = aa.d;
                    z = r.en(0 + y, h);
                    let ab = r.en(0, h);
                    z -= ab;
                }
            }
            for (let ac = 0; ac < this.yn.c.count; ac++) {
                t = v.item(ac);
                u = w.item(ac);
                if (x) {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ek(t, h);
                        c[ac].y = s.ek(u, i);
                    }
                    else {
                        if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                            c[ac].x = r.ek(t, h) + y;
                            c[ac].y = s.ek(u, i);
                        }
                        else {
                            c[ac].x = NaN;
                            c[ac].y = NaN;
                        }
                    }
                }
                else {
                    if (t >= k && t <= l && u >= m && u <= n) {
                        c[ac].x = r.ek(t, h);
                        c[ac].y = s.ek(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            return c;
        }
        zo(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.dl;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
            }
            return b;
        }
        pu(a) {
            super.pu(a);
            this.bb.exportTrendlineData(this, a, this.yo.c2.g$j);
        }
        iw() {
            return Series.ix(this.y9, null);
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.kl(c);
            let e = d == null ? NaN : this.iv(d, "XMemberPath");
            let f = d == null ? NaN : this.iv(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.l = e;
            g.a = 13;
            g.q = "X";
            g.r = this.aak != null ? this.aak : "X";
            g.s = this.aag != null ? this.aag : "X:";
            g.t = this.aai != null ? this.aai : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.q = "Y";
            h.r = this.aas != null ? this.aas : "Y";
            h.s = this.aao != null ? this.aao : "Y:";
            h.t = this.aaq != null ? this.aaq : "";
            let i = new DataLegendSeriesContext();
            i.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.h = this.l9();
            return i;
        }
        abi() {
            if (this.za) {
                this.zp = 0;
                this.zq = 0;
                for (let a = 0; a < this.y8.count; a++) {
                    this.zp += this.y8.item(a);
                    this.zq += this.y9.item(a);
                }
                this.zr = this.zp / this.y8.count;
                this.zs = this.zq / this.y9.count;
                this.za = false;
            }
        }
        i6(a, b) {
            if (b == null || !b.cj) {
                return NaN;
            }
            if (b != this.xAxis && b != this.yAxis) {
                return NaN;
            }
            let c = this.ap(a);
            if (b.cp) {
                return c[1];
            }
            else {
                return c[0];
            }
        }
        ap(a) {
            let b = NaN;
            let c = NaN;
            switch (a) {
                case 5:
                case 2:
                    b = this.y8.maximum;
                    c = this.y9.maximum;
                    break;
                case 4:
                case 1:
                    b = this.y8.minimum;
                    c = this.y9.minimum;
                    break;
                case 6:
                case 3:
                    if (this.za) {
                        this.abi();
                    }
                    b = this.zr;
                    c = this.zs;
                    break;
            }
            return [b, c];
        }
        v9(a) {
            let b = this.getEffectiveViewport1(this.ct);
            let c = new ScalerParams(0, this.ct.by, this.ct.bx, this.xAxis.ch, b);
            c.c = b;
            let d = isNaN_(a[0]) ? NaN : this.xAxis.ek(a[0], c);
            c = new ScalerParams(0, this.ct.by, this.ct.bx, this.yAxis.ch, b);
            c.b = this.iw();
            c.c = b;
            let e = isNaN_(a[1]) ? NaN : this.yAxis.ek(a[1], c);
            return { $type: Point_$type, x: d, y: e };
        }
        v8(a) {
            let b = this.ap(a);
            return this.v9(b);
        }
    }
    ScatterBase.$t = /*@__PURE__*/ markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.abj = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    ScatterBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:yp:abk', [ScatterErrorBarSettings.$, null], 'HighlightedXMemberPath:z4:abl', [2, null], 'HighlightedYMemberPath:z6:abm', [2, null], 'IsCustomScatterMarkerStyleAllowed:zf:abn', [0, false], 'IsCustomScatterStyleAllowed:zg:abo', [0, false], 'ItemSearchMode:yz:abp', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:zz:abq', [1, 10000], 'MarkerCollisionAvoidance:yk:abr', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:z0:abs', [1, 400], 'XAxis::ab0', [NumericXAxis.$, null], 'XMemberAsLegendLabel:aag:ab1', [2, null], 'XMemberAsLegendUnit:aai:ab2', [2, null], 'XMemberPath:aak:ab3', [2, null], 'YAxis::ab4', [NumericYAxis.$, null], 'YMemberAsLegendLabel:aao:ab5', [2, null], 'YMemberAsLegendUnit:aaq:ab6', [2, null], 'YMemberPath:aas:ab7', [2, null], 'TrendLineType::aby', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::abx', [1, 1.5], 'TrendLinePeriod::abw', [1, 7], 'TrendLineBrush::abt', [Brush.$, null], 'TrendLineZIndex:z1:abz', [1, 1001], 'TrendLineDashArray:ab9:abu', [DoubleCollection.$], 'TrendLineDashCap:aca:abv', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
})();
/**
 * @hidden
 */
export let ScatterSeriesRenderManager = /*@__PURE__*/ (() => {
    class ScatterSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.aw = null;
            this.ax = null;
        }
        c() {
            this.aw = new AssigningScatterMarkerStyleEventArgs();
            return this.aw;
        }
        a() {
            this.ax = new AssigningScatterStyleEventArgs();
            return this.ax;
        }
        ay(a, b, c) {
            this.w(a, b, c);
        }
        az(a, b, c) {
            this.x(a, b, c);
        }
        a0(a, b, c, d) {
            if (b == -1) {
                a.e = false;
                a.z = 0;
                a.y = c - 1;
            }
            else {
                if (d) {
                    a.z = b;
                    a.y = b;
                }
                else {
                    a.e = false;
                    a.z = b;
                    a.y = b;
                }
            }
        }
    }
    ScatterSeriesRenderManager.$t = /*@__PURE__*/ markType(ScatterSeriesRenderManager, 'ScatterSeriesRenderManager', SeriesRenderManager.$);
    return ScatterSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ScatterBaseView = /*@__PURE__*/ (() => {
    class ScatterBaseView extends MarkerSeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.cy = null;
            this.c1 = null;
            this.c6 = null;
            this.dh = null;
            this.di = null;
            this.c2 = null;
            this.dg = null;
            this.c3 = null;
            this.c1 = a;
            this.c3 = new HashPool$2(Base.$, Marker.$);
            this.cm(this.c3);
            this.c2 = new ScatterTrendLineManager();
        }
        au() {
            super.au();
            this.c0 = this.cz();
            this.dh = new Path();
            this.di = new Path();
            if (!this.q) {
                this.c1.z0 = 2000;
            }
        }
        dj(a) {
            if (this.dg == null) {
                this.dg = new DataTemplateMeasureInfo();
                this.dg.context = this.k.h();
            }
            this.dg.width = a.width;
            this.dg.height = a.height;
            this.dg.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.dg);
            }
            return new Size(1, this.dg.width, this.dg.height);
        }
        cz() {
            let a = new NumericMarkerManager(1, (b) => this.c3.item(b), (b) => this.c1.yn.c.item(b), runOn(this, this.de), runOn(this, this.cw), runOn(this, this.c4), () => this.c1.yk);
            a.q = runOn(this, this.dj);
            return a;
        }
        de(a) {
            this.c1.abc(a, this.c3);
        }
        c5() {
            return this.b8;
        }
        cx() {
            return this.cy;
        }
        cw() {
            this.cy = this.c1.yf(this, this.c3, this.cy, this.by, this.bx);
            return this.cy;
        }
        c4() {
            this.c6 = this.c1.zo(this.c3, this.c6);
            return this.c6;
        }
        c7() {
        }
        dc(a) {
        }
        c8() {
        }
        dd(a) {
        }
        df() {
            if (this.c1.trendLineBrush != null) {
                this.c1.ab8 = this.c1.trendLineBrush;
            }
            else {
                this.c1.ab8 = this.c1.u2;
            }
        }
        cj(a) {
            this.c3.f(a);
        }
        da(a) {
            this.c3.g(a);
        }
        db() {
        }
        a7(a, b) {
            super.a7(a, b);
            if (a.d) {
                if (this.c1.trendLineType != 0 && !b) {
                    let c = this.c2.g$j;
                    c.ad = this.c1.trendLineThickness;
                    c._stroke = this.c1.ab8;
                    c.ai = this.c1.ab9;
                    c.aj = this.c1.aca;
                    a.v(c);
                }
            }
        }
        c9(a) {
            if (a) {
                this.db();
                this.c3.clear();
            }
            this.c2.g$d();
            this.as();
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a9.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.c1.title + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.c1.aak + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.c1.aas + "}</span></div>";
            return a;
        }
    }
    ScatterBaseView.$t = /*@__PURE__*/ markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
})();
